//////////////////////////////////////////////////
//////////////Shadow Combine Shader///////////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////02.09.2009////////////////by Nils Daumann/////
///////////////www.ssmasters.de///////////////////
//////////////////////////////////////////////////

float4 vecSkill1;
float4 vecSkill5;

Texture TargetMap;
Texture mtlSkin1;
Texture mtlSkin2;
Texture mtlSkin3;
Texture mtlSkin4;

sampler colMap = sampler_state
{
	texture = <TargetMap>;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter = LINEAR;
	AddressU = clamp;
	AddressV = clamp;
};

sampler shad2Map = sampler_state
{
	texture = <mtlSkin2>;
	magfilter = LINEAR;
	minfilter = LINEAR;
	mipfilter = LINEAR;
	AddressU = clamp;
	AddressV = clamp;
};


float4 ps_main(float2 TexCoord : TEXCOORD0_centroid) : COLOR0
{
	float4 Color = tex2D(colMap,TexCoord);
	float4 Shad2 = tex2D(shad2Map,TexCoord);
	
	float3 Shadow = saturate(/*float3(81.0f/255.0f, 121.0f/255.0f, 199.0f/255.0f)*0.25+*/vecSkill5.xyz+Shad2.rgb);
	return Color*float4(Shadow,1.0);
}

technique Main
{
	pass RenderShadowMap
	{
		PixelShader = compile ps_2_0 ps_main();
	}
}
