//////////////////////////////////////////////////
////////Simple Depthmap Shader for the Sun////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////02.09.2009////////////////by Nils Daumann/////
///////////////www.slindev.com////////////////////
//////////////////////////////////////////////////

// Constants given by the engine
float4x4 matWorld;
float4x4 matMtl;
float4x4 matView;
float4x4 matProj;
float4x4 matWorldViewProj;
float4x4 matViewProj;

float4 vecViewPos;
float4 vecSunPos;

// Textures
texture entSkin1;

sampler ColorMapSampler = sampler_state
{
	Texture = <entSkin1>;
	MipFilter = LINEAR;
};

// Structs
struct SMapVertexToPixel
{
    float4 Position     : POSITION;
    float2 TexCoords    : TEXCOORD0;
    float4 Pos				: TEXCOORD1;
};

// Vertex Shader
SMapVertexToPixel ShadowMapVertexShader(float4 inPos : POSITION, float2 texcoords : TEXCOORD0)
{
   SMapVertexToPixel Output;
	
	Output.Pos = mul(inPos,matWorld);
   Output.Position = mul(Output.Pos,matMtl);

   Output.TexCoords.xy = texcoords;

   return Output;
}

// Pixel Shader
float4 ShadowMapPixelShader(SMapVertexToPixel PSIn) : COLOR0
{
	clip(tex2D(ColorMapSampler,PSIn.TexCoords).a-0.5);

	float depth = length(vecViewPos.xyz-PSIn.Pos.xyz);

	return depth;
}


// Technique
technique ShadowMap
{
	pass Pass0
	{
		CullMode = CCW;
//		ZEnable = False;
//		ZFunc = Always;
		ZWriteEnable = True;
		AlphaBlendEnable = False;
		ColorWriteEnable = Alpha;
		
		VertexShader = compile vs_2_0 ShadowMapVertexShader();
		PixelShader = compile ps_2_0 ShadowMapPixelShader();
	}
}